import { Routes } from '@angular/router';
import { ErrorComponent } from './error';
import { loginGuard } from './guards/login.guard';
import { HomeComponent } from './home.component';
import { OtherComponent } from './other.component';

// sovelluksen reitit
// huomaa että other-reitti on suojattu guardilla ja lazy-reitissä on lazy loading

export const routes: Routes = [
  { path: '', redirectTo: '/home', pathMatch: 'full' },
  { path: 'home', component: HomeComponent },
  { path: 'other/:id', component: OtherComponent, canActivate: [loginGuard] },
  // lazy eli laiska komponentti ladataan vain silloin kun sitä tarvitaan eli klikataan linkkiä
  // laiskat komponentit nopeuttavat sovelluksen latautumista, koska niitä ei ladata heti alussa.
  {
    path: 'lazy',
    loadComponent: () =>
      import('./lazy.component').then((m) => m.LazyComponent),
  },
  { path: '**', component: ErrorComponent },
];
