// Funktionaalinen guard, jolla suojataan reitti loggautumattomilta käyttäjiltä
import { inject } from '@angular/core';
import { Router } from '@angular/router';
/*
loginGuard on ns. funktionaalinen guard, joka tuli käyttöön Angularin versiossa 15.
Jos loginGuard palauttaa true, reitti toimii. Muuten Guard palauttaa reitin 
loginform-näkymään, jota ei ole olemassa, joten käyttäjä ohjataan error-näkymään.
*/
  export function loginGuard(): boolean {
    // service tai muu luokka voitaisiin ottaa funktiossa käyttöön näin:
    // const authservice = inject(AuthService);
    // Feikkiloggautuminen: randomilla true tai false
    const loggedIn: boolean = Math.random() < 0.5;
    if(loggedIn) {
      return true;
    } else {
      window.alert('LoginGuard: The user is not logged in and can\'t navigate to OtherComponent');
      // siirrytään loginformiin, ja jos sitä ei ole mennään error-sivulle
      inject(Router).navigate(['./loginform']);
      return false;
    }
  };


/*

// Vanhentunut luokkapohjainen guard

import { CanActivate } from '@angular/router';
import { Injectable } from '@angular/core';

// LoginGuard on apulaisluokka (helper), jolla voidaan tehdä reitityksen esto.
// Guardin runko voidaan luoda Angular CLI:llä komennolla: ng g guard guardinnimi.
// Kun canActivate() -metodi palauttaa true, on reitti auki, muuten kiinni.

@Injectable({
  providedIn: 'root'
})
export class LoginGuard implements CanActivate {

  canActivate(): boolean {
    return this.checkIfLoggedIn();
  }

  private checkIfLoggedIn(): boolean {
    // Feikkiloggautuminen: randomilla true tai false
    const loggedIn: boolean = Math.random() < 0.5;
    console.log(loggedIn);

    if (!loggedIn) {
      window.alert('LoginGuard: The user is not logged in and can\'t navigate to OtherComponent');
    }
    return loggedIn;
  }
}

*/
